#ifndef __IOREGS_H__
#define __IOREGS_H__

unsigned int ioreg_address[] =
{
	0x04000000,
	0x04000002,
	0x04000004,
	0x04000006,
	0x04000008,
	0x0400000a,
	0x0400000c,
	0x0400000e,
	0x04000010,
	0x04000012,
	0x04000014,
	0x04000016,
	0x04000018,
	0x0400001a,
	0x0400001c,
	0x0400001e,
	0x04000020,
	0x04000022,
	0x04000024,
	0x04000026,
	0x04000028,
	0x0400002a,
	0x0400002c,
	0x0400002e,
	0x04000030,
	0x04000032,
	0x04000034,
	0x04000036,
	0x04000038,
	0x0400003a,
	0x0400003c,
	0x0400003e,
	0x04000040,
	0x04000042,
	0x04000044,
	0x04000046,
	0x04000048,
	0x0400004a,
	0x0400004c,
	0x04000050,
	0x04000052,
	0x04000054,
	0x04000068,
	0x0400006A,
	0x0400006C,
	0x04000240,
	0x04000242,
	0x04000244,
	0x04000246,
	0x04000248,
	0x04000304,
	0x04001000,
	0x04001002,
	0x04001008,
	0x0400100a,
	0x0400100c,
	0x0400100e,
	0x04001050,
	0x04001052,
	0x04001054
};


char ioreg_descr[60][16][32] = 
{
	{
		"BG mode","","",
		"BG0 2D/3D",
		"Character OBJ mapping mode",
		"Bitmap OBJ mapping mode","",
		"Forced blank",
		"Display BG0",
		"Display BG1",
		"Display BG2",
		"Display BG3",
		"Display OBJ",
		"Display window 0",
		"Display window 1",
		"Display OBJ window"
	},
	{
		"Display mode","",
		"VRAM selection","",
		"Character OBJ ext. mapping mode","",
		"Bitmap OBJ ext. mapping mode",
		"OAM access during H-blank",
		"Master character offset","","",
		"Master screen offset","","",
		"Ext. BG palette master enable",
		"Ext. OBJ palette master enable"
	},
	{
		"V-Blank flag",
		"H-Blank flag",
		"V-Counter flag",
		"V-Blank IRQ enable",
		"H-Blank IRQ enable",
		"V-Counter IRQ enable",
		"Unused",
		"V-Count","","","","","","","",""
		},
	{
		"Current scanline","","","","","","","","",
		"","","","","","",""
	},
	{
		"Priority","",
		"Character base block","","","",
		"Mosaic enable",
		"Color mode",
		"Screen base block","","","","",
		"Palette set 0/2",
		"Screen size",""
	},
	{
		"Priority","",
		"Character base block","","","",
		"Mosaic enable",
		"Color mode",
		"Screen base block","","","","",
		"Palette set 1/3",
		"Screen size",""
	},
	{
		"Priority","",
		"Character base block","","","",
		"Mosaic enable",
		"Color mode",
		"Screen base block","","","","",
		"Overflow area wraparound",
		"Screen size",""
	},
	{
		"Priority","",
		"Character base block","","","",
		"Mosaic enable",
		"Color mode",
		"Screen base block","","","","",
		"Overflow area wraparound",
		"Screen size",""
	},
	{
		"Offset","","","","","","","","",
		"","","","","","",""
	},
	{
		"Offset","","","","","","","","",
		"","","","","","",""
	},
	{
		"Offset","","","","","","","","",
		"","","","","","",""
	},
	{
		"Offset","","","","","","","","",
		"","","","","","",""
	},
	{
		"Offset","","","","","","","","",
		"","","","","","",""
	},
	{
		"Offset","","","","","","","","",
		"","","","","","",""
	},
	{
		"Offset","","","","","","","","",
		"","","","","","",""
	},
	{
		"Offset","","","","","","","","",
		"","","","","","",""
	},
	{"","","","","","","","","","","","","","","",""},
	{"","","","","","","","","","","","","","","",""},
	{"","","","","","","","","","","","","","","",""},
	{"","","","","","","","","","","","","","","",""},
	{"","","","","","","","","","","","","","","",""},
	{"","","","","","","","","","","","","","","",""},
	{"","","","","","","","","","","","","","","",""},
	{"","","","","","","","","","","","","","","",""},
	{"","","","","","","","","","","","","","","",""},
	{"","","","","","","","","","","","","","","",""},
	{"","","","","","","","","","","","","","","",""},
	{"","","","","","","","","","","","","","","",""},
	{"","","","","","","","","","","","","","","",""},
	{"","","","","","","","","","","","","","","",""},
	{"","","","","","","","","","","","","","","",""},
	{"","","","","","","","","","","","","","","",""},
	{"","","","","","","","","","","","","","","",""},
	{"","","","","","","","","","","","","","","",""},
	{"","","","","","","","","","","","","","","",""},
	{"","","","","","","","","","","","","","","",""},
	{"","","","","","","","","","","","","","","",""},
	{"","","","","","","","","","","","","","","",""},
	{"","","","","","","","","","","","","","","",""},
	{
		"BG0 1st target pixel","BG1 1st target pixel","BG2 1st target pixel",
		"BG3 1st target pixel","OBJ 1st target pixel","BD  1st target pixel",
		"Color special effect","","BG0 2nd target pixel","BG1 2nd target pixel",
		"BG2 2nd target pixel","BG3 2nd target pixel","OBJ 2nd target pixel",
		"BD  2nd target pixel","Unused",""
	},
	{
		"EVA coefficient","","","","",
		"Unused","","",
		"EVB coefficient","","","","",
		"Unused","",""
	},
	{"EVY coefficient","","","","","Unused","","","","","","","","","",""},
	{
		"Red","","","","",
		"Green","","","","",
		"Blue","","","","",
		"Unused (?)"
	},
	{
		"Red","","","","",
		"Green","","","","",
		"Blue","","","","",
		"Unused (?)"
	},
	{
		"Brightness","","","","",
		"Unused","","","","","","","","",
		"Mode",""
	},
	{"Bank A type","","Bank A offset","","","Unused","","Bank A enable",
	 "Bank B type","","Bank B offset","","","Unused","","Bank B enable"},
	{"Bank C type","","Bank C offset","","","Unused","","Bank C enable",
	 "Bank D type","","Bank D offset","","","Unused","","Bank D enable"},
	{"Bank E type","","Unused","","","","","Bank E enable",
	 "Bank F type","","Bank F offset","","","Unused","","Bank F enable"},
	{"Bank G type","","Bank G offset","","","Unused","","Bank G enable",
	 "WRAM bank","","Unused","","","","",""},
	{"Bank H type","","Unused","","","","","Bank H enable",
	 "Bank I type","","Unused","","","","","Bank I enable"},
	{"LCD","2D unit","3D rendering unit (?)","3D geometry unit (?)","Unused","","","",
	 "Sub LCD","Sub 2D unit","Unused","","","","","Display selection"},
	{
		"BG mode","","",
		"Unused (?)",
		"Character OBJ mapping mode",
		"Bitmap OBJ mapping mode","",
		"Forced blank",
		"Display BG0",
		"Display BG1",
		"Display BG2",
		"Display BG3",
		"Display OBJ",
		"Display window 0",
		"Display window 1",
		"Display OBJ window"
	},
	{
		"Display mode","Unused (?)",
		"","",
		"Character OBJ ext. mapping mode","",
		"Bitmap OBJ ext. mapping mode",
		"Unknown",
		"Master character offset","","",
		"Master screen offset","","",
		"Ext. BG palette master enable",
		"Ext. OBJ palette master enable"
	},
	{
		"Priority","",
		"Character base block","","","",
		"Mosaic enable",
		"Color mode",
		"Screen base block","","","","",
		"Palette set 0/2",
		"Screen size",""
	},
	{
		"Priority","",
		"Character base block","","","",
		"Mosaic enable",
		"Color mode",
		"Screen base block","","","","",
		"Palette set 0/2",
		"Screen size",""
	},
	{
		"Priority","",
		"Character base block","","","",
		"Mosaic enable",
		"Color mode",
		"Screen base block","","","","",
		"Palette set 0/2",
		"Screen size",""
	},
	{
		"Priority","",
		"Character base block","","","",
		"Mosaic enable",
		"Color mode",
		"Screen base block","","","","",
		"Palette set 0/2",
		"Screen size",""
	},
	{
		"BG0 1st target pixel","BG1 1st target pixel","BG2 1st target pixel",
		"BG3 1st target pixel","OBJ 1st target pixel","BD  1st target pixel",
		"Color special effect","","BG0 2nd target pixel","BG1 2nd target pixel",
		"BG2 2nd target pixel","BG3 2nd target pixel","OBJ 2nd target pixel",
		"BD  2nd target pixel","Unused",""
	},
	{
		"EVA coefficient","","","","",
		"Unused","","",
		"EVB coefficient","","","","",
		"Unused","",""
	},
	{"EVY coefficient","","","","","Unused","","","","","","","","","",""}

};



#endif
